Index: uspace/lib/inet/include/inet/dnsr.h
===================================================================
--- uspace/lib/inet/include/inet/dnsr.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/dnsr.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2013 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_DNSR_H
+#define LIBINET_INET_DNSR_H
+
+#include <inet/inet.h>
+#include <inet/addr.h>
+
+enum {
+	DNSR_NAME_MAX_SIZE = 255
+};
+
+typedef struct {
+	/** Host canonical name */
+	char *cname;
+	/** Host address */
+	inet_addr_t addr;
+} dnsr_hostinfo_t;
+
+extern errno_t dnsr_init(void);
+extern errno_t dnsr_name2host(const char *, dnsr_hostinfo_t **, ip_ver_t);
+extern void dnsr_hostinfo_destroy(dnsr_hostinfo_t *);
+extern errno_t dnsr_get_srvaddr(inet_addr_t *);
+extern errno_t dnsr_set_srvaddr(inet_addr_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/endpoint.h
===================================================================
--- uspace/lib/inet/include/inet/endpoint.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/endpoint.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_ENDPOINT_H
+#define LIBINET_INET_ENDPOINT_H
+
+#include <stdint.h>
+#include <inet/addr.h>
+#include <loc.h>
+
+/** Internet port number ranges
+ *
+ * Port number ranges per RFC 6335 section 6 (Port Number Ranges.
+ * Technically port zero is a system port. But since it is reserved,
+ * we will use it as a special value denoting no port is specified
+ * and we will exclude it from the system port range to disallow
+ * ever assigning it.
+ */
+enum inet_port_ranges {
+	/** Special value meaning no specific port */
+	inet_port_any = 0,
+	/** Lowest system port (a.k.a. well known port) */
+	inet_port_sys_lo = 1,
+	/** Highest system port (a.k.a. well known port) */
+	inet_port_sys_hi = 1023,
+	/** Lowest user port (a.k.a. registered port) */
+	inet_port_user_lo = 1024,
+	/** Highest user port (a.k.a. registered port) */
+	inet_port_user_hi = 49151,
+	/** Lowest dynamic port (a.k.a. private or ephemeral port) */
+	inet_port_dyn_lo = 49152,
+	/** Highest dynamic port (a.k.a. private or ephemeral port) */
+	inet_port_dyn_hi = 65535
+};
+
+/** Internet endpoint (address-port pair), a.k.a. socket */
+typedef struct {
+	inet_addr_t addr;
+	uint16_t port;
+} inet_ep_t;
+
+/** Internet endpoint pair */
+typedef struct {
+	service_id_t local_link;
+	inet_ep_t local;
+	inet_ep_t remote;
+} inet_ep2_t;
+
+extern void inet_ep_init(inet_ep_t *);
+extern void inet_ep2_init(inet_ep2_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/eth_addr.h
===================================================================
--- uspace/lib/inet/include/inet/eth_addr.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/eth_addr.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/**
+ * @file
+ * @brief
+ */
+
+#ifndef LIBINET_INET_ETH_ADDR_H
+#define LIBINET_INET_ETH_ADDR_H
+
+#include <stdint.h>
+
+#define ETH_ADDR_SIZE 6
+#define ETH_ADDR_STR_SIZE (6 * 2 + 5)
+
+#define ETH_ADDR_INITIALIZER(aa, bb, cc, dd, ee, ff) \
+    { .a = ((uint64_t)(aa) << 40) | ((uint64_t)(bb) << 32) | \
+    ((uint64_t)(cc) << 24) | ((uint64_t)(dd) << 16) | \
+    ((uint64_t)(ee) << 8) | (ff) }
+
+/** Ethernet address.
+ *
+ * Defined as a structure. This provides strong type checking.
+ *
+ * Since the structure is not opaque, this allows eth_addr_t to be
+ * allocated statically and copied around using the assignment operator.
+ *
+ * It is stored in the lower 48 bits of a 64-bit integer. This is an internal
+ * representation that allows simple and efficient operation. Most CPUs
+ * will be much faster (and we will need less instructions) operating
+ * on a single 64-bit integer than on six individual 8-bit integers.
+ *
+ * Kind reader will appreciate the cleverness and elegance of this
+ * representation.
+ */
+typedef struct {
+	uint64_t a;
+} eth_addr_t;
+
+/** Ethernet address in the form of a string */
+typedef struct {
+	char str[ETH_ADDR_STR_SIZE + 1];
+} eth_addr_str_t;
+
+extern const eth_addr_t eth_addr_broadcast;
+
+extern void eth_addr_encode(eth_addr_t *, uint8_t *);
+extern void eth_addr_decode(const uint8_t *, eth_addr_t *);
+
+extern int eth_addr_compare(const eth_addr_t *, const eth_addr_t *);
+extern void eth_addr_format(eth_addr_t *, eth_addr_str_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/host.h
===================================================================
--- uspace/lib/inet/include/inet/host.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/host.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2016 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_HOST_H
+#define LIBINET_INET_HOST_H
+
+#include <inet/addr.h>
+#include <inet/endpoint.h>
+#include <types/inet/hostport.h>
+
+extern errno_t inet_host_parse(const char *, inet_host_t **, char **);
+extern errno_t inet_host_format(inet_host_t *, char **);
+extern void inet_host_destroy(inet_host_t *);
+extern errno_t inet_host_lookup_one(inet_host_t *, ip_ver_t, inet_addr_t *);
+extern errno_t inet_host_plookup_one(const char *, ip_ver_t, inet_addr_t *,
+    char **, const char **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/hostname.h
===================================================================
--- uspace/lib/inet/include/inet/hostname.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/hostname.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2016 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_HOSTNAME_H
+#define LIBINET_INET_HOSTNAME_H
+
+extern errno_t inet_hostname_parse(const char *, char **, char **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/hostport.h
===================================================================
--- uspace/lib/inet/include/inet/hostport.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/hostport.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2016 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_HOSTPORT_H
+#define LIBINET_INET_HOSTPORT_H
+
+#include <inet/addr.h>
+#include <inet/endpoint.h>
+#include <types/inet/hostport.h>
+
+extern errno_t inet_hostport_parse(const char *, inet_hostport_t **, char **);
+extern errno_t inet_hostport_format(inet_hostport_t *, char **);
+extern void inet_hostport_destroy(inet_hostport_t *);
+extern errno_t inet_hostport_lookup_one(inet_hostport_t *, ip_ver_t, inet_ep_t *);
+extern errno_t inet_hostport_plookup_one(const char *, ip_ver_t, inet_ep_t *,
+    char **, const char **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/inet.h
===================================================================
--- uspace/lib/inet/include/inet/inet.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/inet.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2012 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_INET_H
+#define LIBINET_INET_INET_H
+
+#include <inet/addr.h>
+#include <ipc/loc.h>
+#include <stdint.h>
+#include <types/inet.h>
+
+extern errno_t inet_init(uint8_t, inet_ev_ops_t *);
+extern errno_t inet_send(inet_dgram_t *, uint8_t, inet_df_t);
+extern errno_t inet_get_srcaddr(inet_addr_t *, uint8_t, inet_addr_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/inetcfg.h
===================================================================
--- uspace/lib/inet/include/inet/inetcfg.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/inetcfg.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2012 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_INETCFG_H
+#define LIBINET_INET_INETCFG_H
+
+#include <inet/inet.h>
+#include <stddef.h>
+#include <types/inetcfg.h>
+
+extern errno_t inetcfg_init(void);
+extern errno_t inetcfg_addr_create_static(const char *, inet_naddr_t *, sysarg_t, sysarg_t *);
+extern errno_t inetcfg_addr_delete(sysarg_t);
+extern errno_t inetcfg_addr_get(sysarg_t, inet_addr_info_t *);
+extern errno_t inetcfg_addr_get_id(const char *, sysarg_t, sysarg_t *);
+extern errno_t inetcfg_get_addr_list(sysarg_t **, size_t *);
+extern errno_t inetcfg_get_link_list(sysarg_t **, size_t *);
+extern errno_t inetcfg_get_sroute_list(sysarg_t **, size_t *);
+extern errno_t inetcfg_link_add(sysarg_t);
+extern errno_t inetcfg_link_get(sysarg_t, inet_link_info_t *);
+extern errno_t inetcfg_link_remove(sysarg_t);
+extern errno_t inetcfg_sroute_get(sysarg_t, inet_sroute_info_t *);
+extern errno_t inetcfg_sroute_get_id(const char *, sysarg_t *);
+extern errno_t inetcfg_sroute_create(const char *, inet_naddr_t *, inet_addr_t *,
+    sysarg_t *);
+extern errno_t inetcfg_sroute_delete(sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/inetping.h
===================================================================
--- uspace/lib/inet/include/inet/inetping.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/inetping.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2013 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_INETPING_H
+#define LIBINET_INET_INETPING_H
+
+#include <inet/inet.h>
+#include <types/inetping.h>
+
+typedef struct inetping_ev_ops {
+	errno_t (*recv)(inetping_sdu_t *);
+} inetping_ev_ops_t;
+
+extern errno_t inetping_init(inetping_ev_ops_t *);
+extern errno_t inetping_send(inetping_sdu_t *);
+extern errno_t inetping_get_srcaddr(const inet_addr_t *, inet_addr_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/iplink.h
===================================================================
--- uspace/lib/inet/include/inet/iplink.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/iplink.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_IPLINK_H
+#define LIBINET_INET_IPLINK_H
+
+#include <async.h>
+#include <inet/addr.h>
+#include <inet/eth_addr.h>
+
+struct iplink_ev_ops;
+
+typedef struct {
+	async_sess_t *sess;
+	struct iplink_ev_ops *ev_ops;
+	void *arg;
+} iplink_t;
+
+/** IPv4 link Service Data Unit */
+typedef struct {
+	/** Local source address */
+	addr32_t src;
+	/** Local destination address */
+	addr32_t dest;
+	/** Serialized IP packet */
+	void *data;
+	/** Size of @c data in bytes */
+	size_t size;
+} iplink_sdu_t;
+
+/** IPv6 link Service Data Unit */
+typedef struct {
+	/** Local MAC destination address */
+	eth_addr_t dest;
+	/** Serialized IP packet */
+	void *data;
+	/** Size of @c data in bytes */
+	size_t size;
+} iplink_sdu6_t;
+
+/** Internet link receive Service Data Unit */
+typedef struct {
+	/** Serialized datagram */
+	void *data;
+	/** Size of @c data in bytes */
+	size_t size;
+} iplink_recv_sdu_t;
+
+typedef struct iplink_ev_ops {
+	errno_t (*recv)(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
+	errno_t (*change_addr)(iplink_t *, eth_addr_t *);
+} iplink_ev_ops_t;
+
+extern errno_t iplink_open(async_sess_t *, iplink_ev_ops_t *, void *, iplink_t **);
+extern void iplink_close(iplink_t *);
+extern errno_t iplink_send(iplink_t *, iplink_sdu_t *);
+extern errno_t iplink_send6(iplink_t *, iplink_sdu6_t *);
+extern errno_t iplink_addr_add(iplink_t *, inet_addr_t *);
+extern errno_t iplink_addr_remove(iplink_t *, inet_addr_t *);
+extern errno_t iplink_get_mtu(iplink_t *, size_t *);
+extern errno_t iplink_get_mac48(iplink_t *, eth_addr_t *);
+extern errno_t iplink_set_mac48(iplink_t *, eth_addr_t *);
+extern void *iplink_get_userptr(iplink_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/iplink_srv.h
===================================================================
--- uspace/lib/inet/include/inet/iplink_srv.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/inet/include/inet/iplink_srv.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinet
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBINET_INET_IPLINK_SRV_H
+#define LIBINET_INET_IPLINK_SRV_H
+
+#include <async.h>
+#include <fibril_synch.h>
+#include <inet/addr.h>
+#include <inet/eth_addr.h>
+#include <inet/iplink.h>
+#include <stdbool.h>
+
+struct iplink_ops;
+
+typedef struct {
+	fibril_mutex_t lock;
+	bool connected;
+	struct iplink_ops *ops;
+	void *arg;
+	async_sess_t *client_sess;
+} iplink_srv_t;
+
+typedef struct iplink_ops {
+	errno_t (*open)(iplink_srv_t *);
+	errno_t (*close)(iplink_srv_t *);
+	errno_t (*send)(iplink_srv_t *, iplink_sdu_t *);
+	errno_t (*send6)(iplink_srv_t *, iplink_sdu6_t *);
+	errno_t (*get_mtu)(iplink_srv_t *, size_t *);
+	errno_t (*get_mac48)(iplink_srv_t *, eth_addr_t *);
+	errno_t (*set_mac48)(iplink_srv_t *, eth_addr_t *);
+	errno_t (*addr_add)(iplink_srv_t *, inet_addr_t *);
+	errno_t (*addr_remove)(iplink_srv_t *, inet_addr_t *);
+} iplink_ops_t;
+
+extern void iplink_srv_init(iplink_srv_t *);
+
+extern errno_t iplink_conn(ipc_call_t *, void *);
+extern errno_t iplink_ev_recv(iplink_srv_t *, iplink_recv_sdu_t *, ip_ver_t);
+extern errno_t iplink_ev_change_addr(iplink_srv_t *, eth_addr_t *);
+
+#endif
+
+/** @}
+ */
